Skip to content
For the complete documentation index, see llms.txt. Markdown versions of documentation pages are available by appending .md to the page URL.
Primary navigation
Theme

Create image variation

Deprecated
images.create_variation(**kwargs) -> ImagesResponse
POST
/images/variations

This endpoint is retired and no longer available. Use the image edits endpoint with a GPT Image model and a prompt to create a variation of an image. The request and response schemas below describe the legacy contract.

Parameters
image: FileTypes

The image to use as the basis for the variation(s). Must be a valid PNG file, less than 4MB, and square.

model: Optional[Union[str, ImageModel, null]]

The legacy model used by the retired image variations endpoint. This endpoint no longer accepts requests.

Deprecated values:

  • “gpt-image-1”: GPT Image 1 was shut down on October 23, 2026. Use gpt-image-2.5-sunburst or gpt-image-2.5-flare instead.
  • “dall-e-2”, “dall-e-3”: This model was retired on May 12, 2026. Use a GPT image model instead.
n: Optional[int]

The number of images to generate. Must be between 1 and 10.

minimum1
maximum10
response_format: Optional[Literal["url", "b64_json"]]

The format in which the generated images are returned. Must be one of url or b64_json. URLs are only valid for 60 minutes after the image has been generated.

size: Optional[Literal["256x256", "512x512", "1024x1024"]]

The size of the generated images. Must be one of 256x256, 512x512, or 1024x1024.

user: Optional[str]

A unique identifier representing your end-user, which can help OpenAI to monitor and detect abuse. Learn more.

Returns
class ImagesResponse: …

The response from the image generation endpoint.

created: int

The Unix timestamp (in seconds) of when the image was created.

formatunixtime
background: Optional[Literal["transparent", "opaque"]]

The background parameter used for the image generation. Either transparent or opaque.

data: Optional[List[Image]]

The list of generated images.

output_format: Optional[Literal["png", "webp", "jpeg", 2 more]]

The output format of the generated or edited image.

quality: Optional[Literal["low", "medium", "high", 2 more]]

The quality of the image generated. One of low, medium, high, xhigh, or max.

safety_identifier: Optional[str]

The effective safety identifier used for safety monitoring and abuse detection. This is the non-empty safety_identifier from the request, or the deprecated user value when safety_identifier is omitted, null, or empty.

size: Optional[Union[str, Literal["1024x1024", "1024x1536", "1536x1024"], null]]

The image dimensions as a WIDTHxHEIGHT string, for example 1536x864.

svg_usage: Optional[SvgUsage]

Token usage for SVG authoring, separate from image rendering usage.

usage: Optional[Usage]

Token usage information for image generation with GPT Image models.

Create image variation

from openai import OpenAI
client = OpenAI()

response = client.images.create_variation(
  image=open("image_edit_original.png", "rb"),
  n=2,
  size="1024x1024"
)
Response example
{
  "created": 1589478378,
  "data": [
    {
      "url": "https://..."
    },
    {
      "url": "https://..."
    }
  ]
}
Returns Examples
Response example
{
  "created": 1589478378,
  "data": [
    {
      "url": "https://..."
    },
    {
      "url": "https://..."
    }
  ]
}